{

######################################################################
# Grab hosts
nmap -sP 192.168.1.* -oG - \
	| awk '/Status: Up/ { print $2 }' \

192.168.1.124
192.168.1.125
192.168.1.126

    | SNMPsysDescrFilter.pl -m 'Windows' \

192.168.1.124

	| SNMPQueryHosts.pl -D \

192.168.1.124:HG=HomeGroup:CG=HomeAdmin:DS=John\'s Fileserver
192.168.1.125:HG=HomeGroup,WebGroup:CG=WebAdmin
192.168.1.126:HG=HomeGroup,FileServers:CG=FileAdmin

	| SNMPQueryHosts.pl -D -k NE \

192.168.1.124:HG=HomeGroup:CG=HomeAdmin
192.168.1.125:HG=HomeGroup,WebGroup:CG=WebAdmin
192.168.1.126:HG=HomeGroup,FileServers:CG=FileAdmin:NE=1

	| MySQLQueryHosts.pl -D -q 'select type LIKE "Windows"' \

192.168.1.124:HG=HomeGroup:CG=HomeAdmin
192.168.1.125:HG=HomeGroup,WebGroup:CG=WebAdmin
192.168.1.126:HG=HomeGroup,FileServers:CG=FileAdmin

	| WriteHosts.pl \
	-D \
	-O /local/apps/nagios-1.2/Auto/New \
	-d HG=HomeGroup \
	-a HG=HomeGroup \
	-d HT=HostTemplate \
	-k 'NE=notifications_enabled'
	-

######################################################################
# Services

# All disks
awk '/host_name/ {print $2}' /local/apps/nagios-1.2/Auto/New/* | sort | uniq |\

ReturnHostnames.pl /local/apps/nagios-1.2/Auto/New/* \

192.168.1.124
192.168.1.125
192.168.1.126

    | SNMPOIDgrepServices.pl \
	-s OID=1.3.6.1.2.1.25.2.3.1.3 \
	-s 'RegExp=(^\/(?!dev)|^[A-Z]:.*Label.*Serial)' \
	-d 'SC=CheckSNMPDisk!^@@@TARGET@@@$!80!90' \

192.168.1.126:SC=CheckSNMPDisk!^A:$!80!90
192.168.1.126:SC=CheckSNMPDisk!^C:$!80!90
192.168.1.126:SC=CheckSNMPDisk!^D:$!80!90

	| SNMPKeyQueryServices.pl \
	-s Key=PL 
	-d 'SC=CheckSNMPProcess!@@@TARGET@@@!0,10!0,50' \

Nagios: HG=HomeGroup:PL=apache,java,sshd

192.168.1.126:SC=CheckSNMPProcess!apache!0,10!0,50
192.168.1.126:SC=CheckSNMPProcess!java!0,10!0,50
192.168.1.126:SC=CheckSNMPProcess!sshd!0,10!0,50

	| MySQLQueryServices.pl \
	-q 'select all from disks' \

	| WriteServices.pl \
	-D \
	-O /local/apps/nagios-1.2/Auto/New \
	-d CG=HomeAdmins \
	-d ST=DiskServiceTemplate \
	-

######################################################################
# Generate Hostgroups
/local/apps/nagios-1.2/src/nagios-autoconfiguration/GenerateHostGroups.pl \
	-D \
	-I /local/apps/nagios-1.2/Auto/New \
	-O /local/apps/nagios-1.2/Auto/New \
	-d HG=WindowsServers \
	-d 'DS=Windows Servers' \
	-d CG=HomeAdmins

/local/apps/nagios-1.2/src/nagios-autoconfiguration/GenerateHostGroups.pl \
	-D \
	-I /local/apps/nagios-1.2/Auto/New \
	-O /local/apps/nagios-1.2/Auto/New \
	-d HG=LinuxServers \
	-d 'DS=Linux Servers' \
	-d CG=HomeAdmins

/local/apps/nagios-1.2/src/nagios-autoconfiguration/GenerateHostGroups.pl \
	-D \
	-I /local/apps/nagios-1.2/Auto/New \
	-O /local/apps/nagios-1.2/Auto/New \
	-d HG=HomeGroup \
	-d 'DS=Home Systems' \
	-d CG=HomeAdmins


######################################################################
# Verify new configuration
# nagios-New.cfg specifies ~/Auto/New instead of ~/Auto/Current
/usr/local/apps/nagios-1.2/bin/nagios -v ~/etc/nagios-New.cfg \
	&& {

	# Install new files because Nagios validated new config
	MYDATE=`date +"%Y%m%d-%H%M%S"`
	
	# Archive our current config
	mv ~/Auto/Current ~/Auto/Archive/$MYDATE

	# Move in the new one
	mv ~/Auto/New ~/Auto/Current
	mkdir ~/Auto/New
	
	# Restart nagios
	kill -HUP `cat ~/var/nagios.lock`

	# Mail off a diff of what changed to the nagios admin
	diff -x *.log -NaruBr ~/Auto/Archive/$MYDATE/ ~/Auto/Current/ \
		| mail -s "$0: Update Successful $MYDATE" nagios

} || {
	
	MYDATE=`date +"%Y%m%d-%H%M%S"`

	# Update failed, rollback changes.
	
	mv ~/Auto/New ~/Auto/Bad/$MYDATE
	mkdir ~/Auto/New

	# Mail a diff to the nagios admin to alert them to the problem.
	diff -x *.log -NaruBr ~/Auto/Current/ ~/Auto/Bad/$MYDATE/ \
		| mail -s "$0: Update Failed $MYDATE" nagios
	
}

} 2>&1 3>&1 | tee ~/Auto/New/QueryNetwork.log
